#include <ESP8266WiFi.h>
#include <WiFiClient.h>
#include <ESP8266WebServer.h>
#include <ESP8266mDNS.h>
#include <ESP8266HTTPUpdateServer.h>
#include <TimeLib.h>
#include <WiFiUdp.h>

const char* host = "retroclock";
const char* ssid = "YOUR_NETWORK_NAME";
const char* password = "YOUR_NETWORK_PASS";

// NTP Servers:
static const char ntpServerName[] = "ntp4.stratum2.ru";
const int timeZone = 0;     // Time zone

ESP8266WebServer httpServer(80);
ESP8266HTTPUpdateServer httpUpdater;

WiFiUDP Udp;
unsigned int localPort = 8888;  // local port to listen for UDP packets

time_t getNtpTime();
void digitalClockDisplay();
void printDigits(int digits);
void sendNTPpacket(IPAddress &address);

const int D_A0 = 14;
const int D_A1 = 12;
const int D_A2 = 13;
const int D_A3 = 16;
//digits multiplex
const int D_M1 = 5;
const int D_M2 = 4;
const int D_M3 = 2; 
const int D_M4 = 3; //used Rx pin
const int LED1 = 1; //used Tx pin
const int LED2 = 0;
int counter =0;
int counter2 =0;

uint32_t ms,  ms1 = 0; //for timer
uint32_t ms2,  ms3 = 0; 
uint32_t ms4,  ms5 = 0; 
uint32_t ms6,  ms7 = 0; 
void setup() {
  
pinMode(D_A0, OUTPUT); //A0
pinMode(D_A1, OUTPUT); //A1
pinMode(D_A2, OUTPUT); //A2
pinMode(D_A3, OUTPUT); //A3
pinMode(D_M1, OUTPUT); //1
pinMode(D_M2, OUTPUT); //2
pinMode(D_M3, OUTPUT); //3
pinMode(D_M4, OUTPUT); //4
pinMode(LED1, OUTPUT); //LED1
pinMode(LED2, OUTPUT); //LED2

WiFi.mode(WIFI_AP_STA);
  WiFi.begin(ssid, password);

  while(WiFi.waitForConnectResult() != WL_CONNECTED){
    WiFi.begin(ssid, password);
    //Serial.println("WiFi failed, retrying.");
  }

  MDNS.begin(host);

  httpUpdater.setup(&httpServer);
  httpServer.begin();

  MDNS.addService("http", "tcp", 80);

Udp.begin(localPort);
setSyncProvider(getNtpTime);
setSyncInterval(300);
}
time_t prevDisplay = 0; // when the digital clock was displayed

void loop() {
 httpServer.handleClient();
 ms4 = millis();
 if ((ms4-ms5) >= 5) {
  counter++;
  ms5 = ms4;
 }
  if(counter > 3){
    counter = 0;
  }
  if (millis() > 10000) {
    ledimp();
    switchs(); 
  }
  else { 
  demo();
  }
}
  
 void displayig(){
  if (counter == 3){ // 4-я цифра //минуты ед
multiplex(2);
int times = minute() % 10;
digitfunction(times);
  }

  if (counter == 2){ // 3-я цифра //минуты десятые
multiplex(1);
int times = minute() /10;
digitfunction(times);
  }

  if (counter == 1){ // 2-я цифра
multiplex(3);
int times = hour()% 10;;
digitfunction(times);
  }

  if (counter == 0){ // 1-я цифра
multiplex(4);
//int times = (((millis()/1000)  % 3600) / 60)/10;
int times = hour()/10;
digitfunction(times);
  }
}
void displayig2(){
  if (counter == 3){ // 4-я цифра //секунды ед
multiplex(2);
int times = second() %10;
digitfunction(times);
  }

  if (counter == 0){ // 3-я цифра //секунды десятые
multiplex(1);
int times = second() /10;
digitfunction(times);
  }

}
void digit0() {
digitalWrite(D_A0, LOW);
digitalWrite(D_A1, LOW);
digitalWrite(D_A2, LOW);
digitalWrite(D_A3, LOW);
}
void digit1() {

digitalWrite(D_A0, HIGH);
digitalWrite(D_A1, LOW);
digitalWrite(D_A2, LOW);
digitalWrite(D_A3, LOW);
}
void digit2() {
digitalWrite(D_A0, LOW); //A0
digitalWrite(D_A1, HIGH);  //A1
digitalWrite(D_A2, LOW);  //A2
digitalWrite(D_A3, LOW);  //A3
}
void digit3() {
digitalWrite(D_A0, HIGH); //A0
digitalWrite(D_A1, HIGH);  //A1
digitalWrite(D_A2, LOW);  //A2
digitalWrite(D_A3, LOW);  //A3
}
void digit4() {
digitalWrite(D_A0, LOW); //A0
digitalWrite(D_A1, LOW);  //A1
digitalWrite(D_A2, HIGH);  //A2
digitalWrite(D_A3, LOW);  //A3
}
void digit5() {
digitalWrite(D_A0, HIGH); //A0
digitalWrite(D_A1, LOW);  //A1
digitalWrite(D_A2, HIGH);  //A2
digitalWrite(D_A3, LOW);  //A3
}
void digit6() {
digitalWrite(D_A0, LOW); //A0
digitalWrite(D_A1, HIGH);  //A1
digitalWrite(D_A2, HIGH);  //A2
digitalWrite(D_A3, LOW);  //A3
}
void digit7() {
digitalWrite(D_A0, HIGH); //A0
digitalWrite(D_A1, HIGH);  //A1
digitalWrite(D_A2, HIGH);  //A2
digitalWrite(D_A3, LOW);  //A3
}
void digit8() {
digitalWrite(D_A0, LOW); //A0
digitalWrite(D_A1, LOW);  //A1
digitalWrite(D_A2, LOW);  //A2
digitalWrite(D_A3, HIGH);  //A3
}
void digit9() {
digitalWrite(D_A0, HIGH); //A0
digitalWrite(D_A1, LOW);  //A1
digitalWrite(D_A2, LOW);  //A2
digitalWrite(D_A3, HIGH);  //A3
}
void multiplex(int chanel){

if(chanel == 1){digitalWrite(D_M2,  LOW); digitalWrite(D_M3,  LOW); digitalWrite(D_M4,  LOW); digitalWrite(D_M1,  HIGH); }
if(chanel == 2){digitalWrite(D_M1,  LOW); digitalWrite(D_M3,  LOW); digitalWrite(D_M4,  LOW); digitalWrite(D_M2,  HIGH); }
if(chanel == 3){digitalWrite(D_M1,  LOW); digitalWrite(D_M2,  LOW); digitalWrite(D_M4,  LOW); digitalWrite(D_M3,  HIGH); }
if(chanel == 4){digitalWrite(D_M1,  LOW); digitalWrite(D_M2,  LOW); digitalWrite(D_M3,  LOW); digitalWrite(D_M4,  HIGH); }

  }

void digitfunction(int times){
if(times == 0){ digit0();}
if(times == 1){ digit1();}
if(times == 2){ digit2();}
if(times == 3){ digit3();}
if(times == 4){ digit4();}
if(times == 5){ digit5();}
if(times == 6){ digit6();}
if(times == 7){ digit7();}
if(times == 8){ digit8();}
if(times == 9){ digit9();}
//delayMicroseconds(10000);
  } 
void ledimp() {
  ms = millis();   
    if(( ms - ms1 ) >= 0 && ( ms - ms1 ) <= 500){digitalWrite(LED1, HIGH);}
    if(( ms - ms1 ) >= 250 && ( ms - ms1 ) <= 500){digitalWrite(LED2, HIGH);}
    if(( ms - ms1 ) >= 500){digitalWrite(LED1, LOW); digitalWrite(LED2, LOW);}
    if(( ms - ms1 ) >= 1000){ ms1 = ms;}
}
void switchs() {
  ms2 = second(); 
    if(( ms2 ) >= 0 && ( ms2 ) <= 44){displayig();}
    if(( ms2 ) >= 45 && ( ms2  ) <= 60){displayig2();}
}

/*-------- NTP code ----------*/

const int NTP_PACKET_SIZE = 48; // NTP time is in the first 48 bytes of message
byte packetBuffer[NTP_PACKET_SIZE]; //buffer to hold incoming & outgoing packets

time_t getNtpTime()
{
  IPAddress ntpServerIP; // NTP server's ip address

  while (Udp.parsePacket() > 0) ; // discard any previously received packets
  // get a random server from the pool
  WiFi.hostByName(ntpServerName, ntpServerIP);
  sendNTPpacket(ntpServerIP);
  uint32_t beginWait = millis();
  while (millis() - beginWait < 1500) {
    int size = Udp.parsePacket();
    if (size >= NTP_PACKET_SIZE) {
      Udp.read(packetBuffer, NTP_PACKET_SIZE);  // read packet into the buffer
      unsigned long secsSince1900;
      // convert four bytes starting at location 40 to a long integer
      secsSince1900 =  (unsigned long)packetBuffer[40] << 24;
      secsSince1900 |= (unsigned long)packetBuffer[41] << 16;
      secsSince1900 |= (unsigned long)packetBuffer[42] << 8;
      secsSince1900 |= (unsigned long)packetBuffer[43];
      return secsSince1900 - 2208988800UL + timeZone * SECS_PER_HOUR;
    }
  }
  
}

// send an NTP request to the time server at the given address
void sendNTPpacket(IPAddress &address)
{
  // set all bytes in the buffer to 0
  memset(packetBuffer, 0, NTP_PACKET_SIZE);
  // Initialize values needed to form NTP request
  // (see URL above for details on the packets)
  packetBuffer[0] = 0b11100011;   // LI, Version, Mode
  packetBuffer[1] = 0;     // Stratum, or type of clock
  packetBuffer[2] = 6;     // Polling Interval
  packetBuffer[3] = 0xEC;  // Peer Clock Precision
  // 8 bytes of zero for Root Delay & Root Dispersion
  packetBuffer[12] = 49;
  packetBuffer[13] = 0x4E;
  packetBuffer[14] = 49;
  packetBuffer[15] = 52;
  // all NTP fields have been given values, now
  // you can send a packet requesting a timestamp:
  Udp.beginPacket(address, 123); //NTP requests are to port 123
  Udp.write(packetBuffer, NTP_PACKET_SIZE);
  Udp.endPacket();
}

void demo(){
  ms6 = millis();
  if ((ms6-ms7) >= 1) {
  counter2++;
  ms7 = ms6;
 }
  if (counter == 0){ // 4-я цифра 
    multiplex(2);
if(counter2 == 100) { digitfunction(9);}
if(counter2 == 200) { digitfunction(8);}
if(counter2 == 300) { digitfunction(7);}
if(counter2 == 400) { digitfunction(6);}
if(counter2 == 500) { digitfunction(5);}
if(counter2 == 600) { digitfunction(4);}
if(counter2 == 700) { digitfunction(3);}
if(counter2 == 800) { digitfunction(2);}
if(counter2 == 900) { digitfunction(1);}
if(counter2 == 1000) { digitfunction(0);}
  }

  if (counter == 1){ // 3-я цифра 
  multiplex(1);
if(counter2 == 1100) { digitfunction(9);}
if(counter2 == 1200) { digitfunction(8);}
if(counter2 == 1300) { digitfunction(7);}
if(counter2 == 1400) { digitfunction(6);}
if(counter2 == 1500) { digitfunction(5);}
if(counter2 == 1600) { digitfunction(4);}
if(counter2 == 1700) { digitfunction(3);}
if(counter2 == 1800) { digitfunction(2);}
if(counter2 == 1900) { digitfunction(1);}
if(counter2 == 2000) { digitfunction(0);}
  }

  if (counter == 2){ // 2-я цифра
    multiplex(3);
if(counter2 == 2100) { digitfunction(9);}
if(counter2 == 2200) { digitfunction(8);}
if(counter2 == 2300) { digitfunction(7);}
if(counter2 == 2400) { digitfunction(6);}
if(counter2 == 2500) { digitfunction(5);}
if(counter2 == 2600) { digitfunction(4);}
if(counter2 == 2700) { digitfunction(3);}
if(counter2 == 2800) { digitfunction(2);}
if(counter2 == 2900) { digitfunction(1);}
if(counter2 == 3000) { digitfunction(0);}
  }

  if (counter == 3){ // 1-я цифра
    multiplex(4); 
if(counter2 == 3100) { digitfunction(9);}
if(counter2 == 3200) { digitfunction(8);}
if(counter2 == 3300) { digitfunction(7);}
if(counter2 == 3400) { digitfunction(6);}
if(counter2 == 3500) { digitfunction(5);}
if(counter2 == 3600) { digitfunction(4);}
if(counter2 == 3700) { digitfunction(3);}
if(counter2 == 3800) { digitfunction(2);}
if(counter2 == 3900) { digitfunction(1);}
if(counter2 == 4000) { digitfunction(0);}
  }
}

